#! /usr/bin/env python
# -*- coding: UTF-8 -*-

#	╔═══════════════════════════════════════════════════════
#	║
#	║Cristobal Ganter - Pedro Sariego - Sebastian Zuñiga  
#	╚═══════════════════════════════════════════════════════


#Librerias________________________________________________________________________

from Tkinter import *
from time import sleep
from math import sqrt, pi
from random import randint, random

#_________________________________________________________________________________



#Constantes_______________________________________________________________________

g=0.00125

#_________________________________________________________________________________



#Variables________________________________________________________________________


particles=set()

#_________________________________________________________________________________



#Clases___________________________________________________________________________


class part:
	def __init__(self, mass, canvas, x, y, vx, vy): 
		self.mass=mass
		self.rad=sqrt(mass/(pi*4000))
		self.vx=vx
		self.vy=vy
		self.x=x
		self.y=y
		self.ax=1
		self.ay=1
		self.canvas=canvas
		self.oval=self.canvas.create_oval((self.x-self.rad,self.y-self.rad,self.x+self.rad,self.y+self.rad))
		self.cumul=set()
		
	def draw(self):
		self.canvas.move(self.oval, self.vx, self.vy)
	
	def refresh(self):
		self.vx += self.ax
		self.vy += self.ay
		self.x += self.vx
		self.y += self.vy
		if (self.x<0):
			self.vx = -(self.vx)/32.0
			self.x = 0		
		if (self.x>wx):
			self.vx = -(self.vx)/32.0
			self.x = wx
		if (self.y<0):
			self.vy = -(self.vy)/32.0
			self.y = 0		
		if (self.y>wy):
			self.vy = -(self.vy)/32.0
			self.y = wy
		
	def delete(self):
		self.mass=0
		self.rad=0
		self.vx=0
		self.vy=0
		self.ax=0
		self.ay=0
		self.canvas.delete(self.oval)
		self.cumul=set()
		
	def mom(self):
		m=self.mass
		vx=self.vx
		vy=self.vy
		return (vx*m, vy*m)

class Tacumulator:
	cumulos=[]
	
	def join(self, p1, p2):
		c1 = p1.cumul
		c2 = p2.cumul
		l1 = len(c1)
		l2 = len(c2)
		
		if ((l1!=0) & (l2!=0) & (c1!=c2)):
			c1 |= c2
			for p in c2:
				p.cumul=c1
			self.cumulos.remove(c2)
		elif ((l1==0) & (l2!=0)):
			c2.add(p1)
			p1.cumul=c2
		elif ((l1!=0) & (l2==0)):
			c1.add(p2)
			p2.cumul=c1
		elif ((l1==0) & (l2==0)):
			p1.cumul={p1,p2}
			p2.cumul=p1.cumul
			self.cumulos.append(p1.cumul)
		
	def testColition(self, T, p):
		if T == p:
			return
		dx = p.x - T.x
		dy = p.y - T.y
		d = sqrt(dx**2 + dy**2)
		if d < (p.rad+T.rad):
			self.join(T,p)
	
	def order(self, particulaT):
		for particula in particles:
			self.testColition(particulaT, particula)
	
	def createNewP(self, cumulo):
		momx = 0
		momy = 0
		m = 0
		mx = 0
		my = 0
		for particula in cumulo:
			momx += particula.mom()[0]
			momy += particula.mom()[1]
			m += particula.mass
			mx += particula.mass*particula.x
			my += particula.mass*particula.y
			particula.delete()
			particles.remove(particula)
		
		vx = momx/m
		vy = momy/m
		x = mx/m
		y = my/m
		particles.add( part(m, w, x, y, vx, vy) )
	
	def go(self):
		for particula in particles:
			self.order(particula)
			
		for cumulo in self.cumulos:
			self.createNewP(cumulo)
		self.cumulos = []

#_________________________________________________________________________________



#Funciones________________________________________________________________________

def refresha():
	for particula1 in particles:
		particula1.ax = 0
		particula1.ay = 0
		for particula2 in particles:
			if particula1 != particula2:
				dx = particula2.x - particula1.x
				dy = particula2.y - particula1.y
				d = sqrt( dx**2 + dy**2)
					
				a = (g*particula2.mass)/(d**2)
				
				particula1.ax += dx*a/d
				particula1.ay += dy*a/d

#_________________________________________________________________________________



#Main_____________________________________________________________________________

if __name__=='__main__':
	master=Tk()
	wx=1100
	wy=700
	w=Canvas(master, width=1100, height=700)
	w.pack()
	acumulador = Tacumulator()
	
	v=0.5
	for i in range(150):
		particles.add( part(randint(1,20000),w,randint(100,1000),randint(100,600),random()*2-1,random()*2-1) )
	
#	for i in [100,200,300,400,500,600]:
#		particles.add( part(1,w,550,i,0,0) )
	
#	x=5
#	y=6
#	for i in range(x):
#		for j in range(y):
#			particles.add(part(1,w,i*500/x+100,j*500/y+100,0,0))
			
#	particles.add( part(100,w,100,100,0,0) )
#	particles.add( part(1,w,300,100,0,0) )
	
	while True:
		acumulador.go()
		refresha()
		for particula in particles:
			particula.refresh()
			particula.draw()
			master.update()
		sleep(0.005)	
	mainloop()

#_________________________________________________________________________________
